(function () {
    var mid = 1;
    var bridge = hybrid;
    bridge.callbacks = {};
    bridge.send = function (message, callback) {
        message.id = mid;
        this.callbacks[mid] = function (error, result) {
            callback({
                error: error,
                result: result
            });
        };
        mid++;

        var json = JSON.stringify(message);
        this.postMessage(json.toString());
    };

    hybrid_DidFinish = function (id, error, result) {
        var callback = bridge.callbacks[id];
        if (callback) {
            callback(error, result);
            delete bridge.callbacks[id];
        };
    };

    createTemplate = function (template) {
        if (typeof template != 'string') return;
        if (atmn[template]) return;

        atmn[template] = {};
        atmn[template].name = template;
    };

    androidJsonPaser = function(data) {
        return JSON.stringify(data);
    };

    atmn = {
        config: function(config, onReady) {
            bridge.send({
                type: 'config',
                data: config
            }, function(respData) {
                if (respData.error) {
                    onReady(respData.error);
                } else if (respData.result) {
                    var featureList = respData.result;
                    featureList.forEach(function(feature) {
                        if (!atmn[feature]) {
                            atmn[feature] = function() {
                                var args = Array.prototype.slice.call(arguments);
                                var data = args.shift();
                                var callback = args.shift();
                                if (!data) {
                                    data = {};
                                } else if (typeof data === 'function') {
                                    callback = data;
                                    data = {};
                                }
                                if (!callback) {
                                    callback = function() {};
                                }

                                if (typeof callback !== 'function') {
                                    throw new Error('callback is not a function');
                                };

                                bridge.send({
                                    type: feature,
                                    data: data
                                }, function(resp) {
                                    if (resp.error) {
                                        callback(resp.error);
                                    } else {
                                        callback(null, resp.result);
                                    }
                                });
                            };
                        }
                    });
                    onReady(null, respData.result);
                }
            });
        },
    };
})();